' Printing functions

Sub printerPutChar (x as uByte, y as uByte, attr as uByte, c as uByte)
	Poke @printerAsmData, x
	Poke 1 + @printerAsmData, y
	Poke 2 + @printerAsmData, c
	Poke 3 + @printerAsmData, attr
	Asm
		Call printer_putchar
	End Asm
End Sub

Sub printerPutString (x as uByte, y as uByte, attr as uByte, s as String)
	Poke @printerAsmData, x
	Poke 1 + @printerAsmData, y
	Poke 3 + @printerAsmData, attr
	printerPutStringAux (s)
End Sub

Sub printerPutStringAux (s as String)
Asm
	pop bc
	pop de
	pop hl
	push hl
	push de
	push bc
	ld c, (hl)
	inc hl
	ld b, (hl)
	inc hl
	call printer_putstring
End Asm
End Sub

Sub printerAsmContainer
printerAsmData:
Asm
	printer_x:
		defb 0
	printer_y:
		defb 0
	printer_char:
		defb 0
	printer_attr:
		defb 0
	printer_straddr:
		defw 0
		
	printer_putchar:
	
		call printer_getdestinationaddress
		
	printer_putchar_sourceaddress:
		; Source address:
		; printer_charset + printer_char * 8
		ld	a, (printer_char)
	printer_putchar_sourceaddress_2:
		sub	32
		ld	h, 0
		ld	l, a
		add hl, hl
		add	hl, hl
		add	hl, hl
		ld	bc, printer_charset
		add	hl, bc
		
		; char in HL
		; destination in DE
	printer_putchar_direct:
		push de
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		
		; Attribute
		; screen address to attribute address
		
		pop	de
		push de
		
		ld	a, d
		and	24			; 00011000
		rrca
		rrca
		rrca
		or	88
		ld	d, a
		
		ld	a, (printer_attr)
		ld	(de), a
			
		pop	de
		ret
	
		defb 1,2,3,4,5,6,7,8
	printer_putstring:
		push hl
		push bc
		call printer_getdestinationaddress
		pop bc
		pop	hl
	printer_putstring_l0:
		ld	a, (hl)
		push hl
		push bc
		call printer_putchar_sourceaddress_2
		pop bc
		pop	hl
		
		inc	de
		inc hl
		dec	c
		jr	nz, printer_putstring_l0
		ret
	
	printer_getdestinationaddress:
		; Destination address:
		ld	a, (printer_y)
		add	a, a
		ld	h, 0
		ld	l, a
		ld	bc, printer_line_addresses
		add	hl, bc
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		ld	a, (printer_x)
		ld	d, 0
		ld 	e, a
		add	hl, de
		ex	de, hl		
		ret
			
	printer_line_addresses:
		defw $4000,$4020,$4040,$4060,$4080,$40A0,$40C0,$40E0
		defw $4800,$4820,$4840,$4860,$4880,$48A0,$48C0,$48E0
		defw $5000,$5020,$5040,$5060,$5080,$50A0,$50C0,$50E0
	printer_charset:
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	 56, 56, 56, 56,  0, 56, 56, 56
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0, 24, 24,126,126, 24, 24,  0
		defb	  0,  0,  0,  0, 56, 56, 24, 48
		defb	  0,  0,  0,126,126,126,  0,  0
		defb	  0,  0,  0,  0,  0, 56, 56, 56
		defb	 62, 62,126,126,252,252,248,248
		defb	124,254,254,238,238,254,254,124
		defb	124,252,124,124,124,254,254,254
		defb	254,254,190,124,248,254,254,254
		defb	254,254, 62,254,254, 62,254,254
		defb	224,236,236,236,254,254,254, 12
		defb	254,254,248,254,254, 30,254,252
		defb	254,254,248,254,254,238,254,254
		defb	254,254, 28, 60,120,120,240,240
		defb	254,254,238,124,254,238,254,254
		defb	254,254,238,254,254, 30,254,254
		defb	  0, 56, 56, 56,  0, 56, 56, 56
		defb	 56, 56, 56,  0, 56, 56, 24, 48
		defb	  0, 16, 62,126,254,126, 62, 16
		defb	  0,  0,124,124,  0,124,124,  0
		defb	  0,  8,124,126,127,126,124,  8
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,254,198,186,170,190,192,252
		defb	254,254,238,254,254,254,238,238
		defb	254,246,254,252,254,246,246,254
		defb	254,254,254,248,248,254,254,254
		defb	252,254,254,238,238,254,254,252
		defb	254,254,248,252,252,248,254,254
		defb	254,254,248,252,252,248,248,248
		defb	254,254,254,240,246,254,254,254
		defb	238,238,254,254,254,254,238,238
		defb	254,254,124,124,124,124,254,254
		defb	 30, 30, 30, 30,222,222,254,254
		defb	230,238,254,252,252,254,238,230
		defb	248,248,248,248,248,254,254,254
		defb	238,254,254,254,254,254,214,198
		defb	246,246,254,254,254,254,222,222
		defb	254,254,254,238,238,254,254,254
		defb	254,254,238,254,254,248,248,248
		defb	252,252,252,236,236,252,254,254
		defb	254,254,238,254,252,254,254,238
		defb	254,254,248,254,254, 62,254,254
		defb	254,254,254,124,124,124,124,124
		defb	238,238,238,238,254,254,254,254
		defb	238,238,238,238,254,254,124,124
		defb	198,214,254,254,254,254,254,238
		defb	238,254,254,124,124,254,254,238
		defb	238,238,254,254,124,124,124,124
		defb	254,254,254, 60,120,254,254,254
		defb	 16, 56,124,254,124,124,124,124
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	124,124,124,124,254,124, 56, 16
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0,  0,  0,  0,  0,  0
		defb	  0,  0,  0, 31, 31, 24, 24, 24
		defb	  0,  0,  0,255,255,  0,  0,  0
		defb	  0,  0,  0,248,248, 24, 24, 24
		defb	 24, 24, 24, 24, 24, 24, 24, 24
		defb	 24, 24, 24, 31, 31,  0,  0,  0
		defb	 24, 24, 24,248,248,  0,  0,  0
		defb	 24, 24, 24, 31, 31, 24, 24, 24
		defb	  0, 85,  0, 85,  0, 85,  0, 85
		defb	  0, 85,  0, 85,  0, 85,  0,  0
		defb	  0,  0, 56, 37, 57, 37, 56,  0
		defb	  0,  0,231, 21, 21, 21,229,  0
		defb	  0,  0,156, 82, 92, 82, 92,  0
		defb	  0,  0,112,132, 96, 16,228,  0
		defb	  0,  0,  4,  4,  4,  4,  6,  0
		defb	  0,  0,137, 18,155,146,145,  0
		defb	  0,  0,128, 72,192,  0,136,  0
End Asm
End Sub