'' Sound

' Sound code generated by Shiru's BeepFX102

Const SOUNDSTEP as uByte = 0
Const SOUNDTOGGLE as uByte = 1
Const SOUNDBREAK as uByte = 2
Const SOUNDCOLLISION as uByte = 3
Const SOUNDSETBOMB as uByte = 4
Const SOUNDWRONG as uByte = 5

Sub makeSound (nSound as uByte)
	Poke @makeSoundData, nSound
	Asm
		push ix
		push iy
		Call sound_play
		pop iy
		pop ix
	End Asm
End Sub

Sub makeSoundAsmContainer ()
makeSoundData:
Asm
sound_data:
	defb 0
; Efect in A
sound_play:
	ld a, (sound_data)
	ld hl, soundEffectsData	;address of sound effects data

	di
	push iy

	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	push hl
	pop ix			;put it into ix

	;ld a,(23624)	;get border color from BASIC vars to keep it unchanged
	;rra
	;rra
	;rra
	;and 7
	xor a
	ld (sfxRoutineTone_border + 1),a
	ld (sfxRoutineNoise_border + 1),a


readData:
	ld a,(ix+0)		;read block type
	or a
	jr nz,readData_sound
	pop iy
	ei
	ret
	
readData_sound:
	ld c,(ix+1)		;read duration 1
	ld b,(ix+2)
	ld e,(ix+3)		;read duration 2
	ld d,(ix+4)
	push de
	pop iy

	dec a
	jr nz,sfxRoutineNoise



;this routine generate tone with many parameters

sfxRoutineTone:
	ld e,(ix+5)		;freq
	ld d,(ix+6)
	ld a,(ix+9)		;duty
	ld (sfxRoutineTone_duty + 1),a
	ld hl,0

sfxRoutineTone_l0:
	push bc
	push iy
	pop bc
sfxRoutineTone_l1:
	add hl,de
	ld a,h
sfxRoutineTone_duty:
	cp 0
	sbc a,a
	and 16
sfxRoutineTone_border:
	or 0
	out ($fe),a

	dec bc
	ld a,b
	or c
	jr nz,sfxRoutineTone_l1

	ld a,(sfxRoutineTone_duty + 1)
	add a,(ix+10)	;duty change
	ld (sfxRoutineTone_duty + 1),a

	ld c,(ix+7)		;slide
	ld b,(ix+8)
	ex de,hl
	add hl,bc
	ex de,hl

	pop bc
	dec bc
	ld a,b
	or c
	jr nz,sfxRoutineTone_l0

	ld c,11
nextData:
	add ix,bc		;skip to the next block
	jr readData

;this routine generate noise with two parameters

sfxRoutineNoise:
	ld e,(ix+5)		;pitch

	ld d,1
	ld h,d
	ld l,d
sfxRoutineNoise_l0:
	push bc
	push iy
	pop bc
sfxRoutineNoise_l1:
	ld a,(hl)
	and 16
sfxRoutineNoise_border:
	or 0
	out ($fe),a
	dec d
	jr nz,sfxRoutineNoise_l2
	ld d,e
	inc hl
	ld a,h
	and $1f
	ld h,a
sfxRoutineNoise_l2:
	dec bc
	ld a,b
	or c
	jr nz,sfxRoutineNoise_l1

	ld a,e
	add a,(ix+6)	;slide
	ld e,a

	pop bc
	dec bc
	ld a,b
	or c
	jr nz,sfxRoutineNoise_l0

	ld c,7
	jr nextData


soundEffectsData:
	defw soundEffectsData_sfx0
	defw soundEffectsData_sfx1
	defw soundEffectsData_sfx2
	defw soundEffectsData_sfx3
	defw soundEffectsData_sfx4
	defw soundEffectsData_sfx5

soundEffectsData_sfx0:
	defb $02
	defw $0001,$0014,$2000
	defb $00
soundEffectsData_sfx1:
	defb $02
	defw $0003,$02ee,$0064
	defb $01
	defw $000a,$01f4,$00c8,$0004,$0080
	defb $01
	defw $000a,$01f4,$01f4,$fff0,$0080
	defb $00
soundEffectsData_sfx2:
	defb $02
	defw $0005,$03e8,$0037
	defb $01
	defw $0005,$03e8,$0258,$0040,$0080
	defb $00
soundEffectsData_sfx3:
	defb $01
	defw $000a,$01f4,$00c8,$0000,$2080
	defb $01
	defw $000a,$01f4,$00c8,$ffc0,$0080
	defb $00
soundEffectsData_sfx4:
	defb $01
	defw $000a,$00c8,$0258,$0010,$0080
	defb $01
	defw $000a,$00c8,$0258,$ffe0,$0080
	defb $00
soundEffectsData_sfx5:
	defb $01
	defw $000a,$0064,$00c8,$0000,$0080
	defb $01
	defw $000a,$0064,$0000,$0000,$0000
	defb $01
	defw $000a,$012c,$00c8,$0000,$0080
	defb $00

End Asm
End Sub
