	org 60000

playBasic
	ld a,0
play
	ld hl,soundEffectsData	;address of sound effects data

	di
	push iy

	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	push hl
	pop ix			;put it into ix

	ld a,(23624)	;get border color from BASIC vars to keep it unchanged
	rra
	rra
	rra
	and 7
	ld (sfxRoutineTone.border),a
	ld (sfxRoutineNoise.border),a


readData
	ld a,(ix)		;read block type
	or a
	jr nz,.sound
	pop iy
	ei
	ret

.sound
	ld c,(ix+1)		;read duration 1
	ld b,(ix+2)
	ld e,(ix+3)		;read duration 2
	ld d,(ix+4)
	push de
	pop iy

	dec a
	jr nz,sfxRoutineNoise



;this routine generate tone with many parameters

sfxRoutineTone
	ld e,(ix+5)		;freq
	ld d,(ix+6)
	ld a,(ix+9)		;duty
	ld (.duty),a
	ld hl,0

.l0
	push bc
	push iy
	pop bc
.l1
	add hl,de
	ld a,h
.duty=$+1
	cp 0
	sbc a,a
	and 16
.border=$+1
	or 0
	out (#fe),a

	dec bc
	ld a,b
	or c
	jr nz,.l1

	ld a,(.duty)
	add a,(ix+10)	;duty change
	ld (.duty),a

	ld c,(ix+7)		;slide
	ld b,(ix+8)
	ex de,hl
	add hl,bc
	ex de,hl

	pop bc
	dec bc
	ld a,b
	or c
	jr nz,.l0

	ld c,11
nextData
	add ix,bc		;skip to the next block
	jr readData



;this routine generate noise with two parameters

sfxRoutineNoise
	ld e,(ix+5)		;pitch

	ld d,1
	ld h,d
	ld l,d
.l0
	push bc
	push iy
	pop bc
.l1
	ld a,(hl)
	and 16
.border=$+1
	or 0
	out (#fe),a
	dec d
	jr nz,.l2
	ld d,e
	inc hl
	ld a,h
	and #1f
	ld h,a
.l2
	dec bc
	ld a,b
	or c
	jr nz,.l1

	ld a,e
	add a,(ix+6)	;slide
	ld e,a

	pop bc
	dec bc
	ld a,b
	or c
	jr nz,.l0

	ld c,7
	jr nextData


soundEffectsData
	dw .sfx0
	dw .sfx1
	dw .sfx2
	dw .sfx3
	dw .sfx4
	dw .sfx5

.sfx0
	db #02
	dw #0001,#0014,#2000
	db #00
.sfx1
	db #02
	dw #0003,#02ee,#0064
	db #01
	dw #000a,#01f4,#00c8,#0004,#0080
	db #01
	dw #000a,#01f4,#01f4,#fff0,#0080
	db #00
.sfx2
	db #02
	dw #0005,#03e8,#0037
	db #01
	dw #0005,#03e8,#0258,#0040,#0080
	db #00
.sfx3
	db #01
	dw #000a,#01f4,#00c8,#0000,#2080
	db #01
	dw #000a,#01f4,#00c8,#ffc0,#0080
	db #00
.sfx4
	db #01
	dw #000a,#00c8,#0258,#0010,#0080
	db #01
	dw #000a,#00c8,#0258,#ffe0,#0080
	db #00
.sfx5
	db #01
	dw #000a,#0064,#00c8,#0000,#0080
	db #01
	dw #000a,#0064,#0000,#0000,#0000
	db #01
	dw #000a,#012c,#00c8,#0000,#0080
	db #00
